# --COPYRIGHT--,BSD
#  Copyright (c) 2012, Texas Instruments Incorporated
#  All rights reserved.
# 
#  Redistribution and use in source and binary forms, with or without
#  modification, are permitted provided that the following conditions
#  are met:
# 
#  *  Redistributions of source code must retain the above copyright
#     notice, this list of conditions and the following disclaimer.
# 
#  *  Redistributions in binary form must reproduce the above copyright
#     notice, this list of conditions and the following disclaimer in the
#     documentation and/or other materials provided with the distribution.
# 
#  *  Neither the name of Texas Instruments Incorporated nor the names of
#     its contributors may be used to endorse or promote products derived
#     from this software without specific prior written permission.
# 
#  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
#  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
#  THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
#  PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
#  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
#  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
#  PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
#  OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
#  WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
#  OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
#  EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
# --/COPYRIGHT--
#!/bin/bash

list=`ls -1`

function updateMacros {
   cwd=`pwd`
   cd $1/CCS
   exe_list=`ls -1`
   for example in $exe_list
   do
      cp ../../ref/CCS/refctl_adc12_ex1/macros.ini $example
   done
   cd $cwd
}

function updatePARENT {
   cwd=`pwd`
   cd $1/CCS
   exe_list=`ls -1`
   for example in $exe_list
   do
      cd $example
      if [ -f .project ]
      then
      cat .project | sed -e 's/PARENT-6-PROJECT_LOC/MSP430WARE_APP_HOME/' \
	   -e "s|PARENT-2-PROJECT_LOC|MSP430WARE_APP_HOME/examples/driverlib/5xx_6xx/$1|" >/tmp/goober$$

      mv /tmp/goober$$ .project
      else
         echo ".project mising in $1"
      fi
      cd ..
   done
   cd $cwd

}

function updateCproject {
   cwd=`pwd`
   cd $1/CCS
   exe_list=`ls -1`
   for example in $exe_list
   do
      cd $example
      if [ -f .cproject ]
      then
      cat .cproject | sed -e "s|PROJECT_ROOT|MSP430WARE_APP_HOME|"  >/tmp/goober$$
      mv /tmp/goober$$ .cproject
      fi
      cd ..
   done
   cd $cwd

}

for module in $list
do
   if [ -d $module ] 
   then
      echo $module
      #updateMacros $module
      #updatePARENT $module
      updateCproject $module
   fi
done

